using SecuritySystemContracts.BindingModels;
using SecuritySystemContracts.ViewModels;
using SecuritySystemDataModels.Models;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace SecuritySystemDatabaseImplement.Models
{
    public class Implementer : IImplementerModel
    {
        public int Id { get; private set; }
        [Required]
        public string ImplementerFIO { get; private set; } = string.Empty;
        [Required]
        public string Password { get; private set; } = string.Empty;
        [Required]
        public int Qualification { get; private set; }
        [Required]
        public int WorkExperience { get; private set; }
        [ForeignKey("ImplementerId")]
        public virtual List<Order> Orders { get; private set; } = new();
        public static Implementer? Create(ImplementerBindingModel model)
        {
            if (model == null)
            {
                return null;
            }
            return new Implementer()
            {
                Id = model.Id,
                Qualification = model.Qualification,
                Password = model.Password,
                ImplementerFIO = model.ImplementerFIO,
                WorkExperience = model.WorkExperience
            };
        }
        public static Implementer Create(ImplementerViewModel model)
        {
            return new Implementer
            {
                Id = model.Id,
                Qualification = model.Qualification,
                Password = model.Password,
                ImplementerFIO = model.ImplementerFIO,
                WorkExperience = model.WorkExperience
            };
        }
        public void Update(ImplementerBindingModel model)
        {
            if (model == null)
            {
                return;
            }
            Qualification = model.Qualification;
            Password = model.Password;
            ImplementerFIO = model.ImplementerFIO;
            WorkExperience = model.WorkExperience;
        }
        public ImplementerViewModel GetViewModel => new()
        {
            Id = Id,
            Qualification = Qualification,
            Password = Password,
            ImplementerFIO = ImplementerFIO,
            WorkExperience = WorkExperience
        };
    }
}
